unit unit_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    GoButton: TButton;
    Memo2: TMemo;
    CloseButton: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Varin1TypeEditBox: TComboBox;
    Varin2TypeEditBox: TComboBox;
    Label2: TLabel;
    ComparisonTypeEditBox: TComboBox;
    Label3: TLabel;
    CancelButton: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    IncrementUp1: TCheckBox;
    IncrementUp2: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    BooleanCheckBox: TCheckBox;
    Var1StartFromEditBox: TComboBox;
    Var2StartFromEditBox: TComboBox;
    Var1EndAtEditBox: TComboBox;
    Var2EndAtEditBox: TComboBox;
    CompilerBox: TGroupBox;
    Amicus18RadioButton: TRadioButton;
    ProtonRadioButton: TRadioButton;
    DeviceGroupBox: TGroupBox;
    Core14RadioButton: TRadioButton;
    Core14eRadioButton: TRadioButton;
    Core16RadioButton: TRadioButton;
    Var1IncrementsEditBox: TComboBox;
    Var2IncrementsEditBox: TComboBox;
    procedure GoButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure Amicus18RadioButtonClick(Sender: TObject);
    procedure ProtonRadioButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Core14RadioButtonClick(Sender: TObject);
    procedure Core14eRadioButtonClick(Sender: TObject);
    procedure Core16RadioButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrintCode(pText: String);
    procedure PrintMessage(pText: String);
    procedure GetVariableTypes();
    procedure PlaceVariableDeclarations(pVariableType1: Integer; pVariableType2: Integer);
    procedure PlaceComparison(pVariableValue1: Integer; pVariableValue2: Integer);
  end;

var
    Form1: TForm1;
    DLIniFile: TIniFile;
    tCloseButtonPressed: Boolean;
    tCancelButtonPressed: Boolean;
    Global_VariableName1: String;
    Global_VariableName2: String;
    ComparisonType: String;
    Global_VariableType1: Integer;
    Global_VariableType2: Integer;
    Global_tExpressionIsSigned: Boolean;

const
    cType_Byte = 1;
    cType_Word = 2;
    cType_Dword = 3;
    cType_Float = 4;
    cType_SByte = 5;
    cType_SWord = 6;
    cType_SDword = 7;
    cType_Constant = 8;
    cType_SignedConstant = 9;
    cType_FloatConstant = 10;

implementation

{$R *.dfm}
//-----------------------------------------------------------------------------------------
// Close button pressed
procedure TForm1.CloseButtonClick(Sender: TObject);
begin
    tCloseButtonPressed := True;
    Close();
end;
//-----------------------------------------------------------------------------------------
// Cancel Button Pressed
//
procedure TForm1.CancelButtonClick(Sender: TObject);
begin
    tCancelButtonPressed := True;
end;
//-----------------------------------------------------------------------------------------
// Form Close Query event
//
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    //
// Write the current settings to an ini file
//
    DLIniFile.WriteString('Options','Var1Type',Varin1TypeEditBox.Text);
    DLIniFile.WriteString('Options','Var2Type',Varin2TypeEditBox.Text);
    DLIniFile.WriteString('Options','ComparisonType',ComparisonTypeEditBox.Text);
    DLIniFile.WriteBool('Options','Boolean',BooleanCheckBox.Checked);

    DLIniFile.WriteString('Options','Var1Start',Var1StartFromEditBox.Text);
    DLIniFile.WriteString('Options','Var2Start',Var2StartFromEditBox.Text);
    DLIniFile.WriteString('Options','Var1End',Var1EndAtEditBox.Text);
    DLIniFile.WriteString('Options','Var2End',Var2EndAtEditBox.Text);
    DLIniFile.WriteString('Options','Var1Inc',Var1IncrementsEditBox.Text);
    DLIniFile.WriteString('Options','Var2Inc',Var2IncrementsEditBox.Text);
    DLIniFile.WriteBool('Options','Var1Up',IncrementUp1.Checked);
    DLIniFile.WriteBool('Options','Var2Up',IncrementUp2.Checked);
    //
    // Compiler type
    //
    DLIniFile.WriteBool('Options','Amicus18',Amicus18RadioButton.Checked);
    DLIniFile.WriteBool('Options','Proton',ProtonRadioButton.Checked);
    //
    // Device type
    //
    DLIniFile.WriteBool('Options','Core14',Core14RadioButton.Checked);
    DLIniFile.WriteBool('Options','Core14e',Core14eRadioButton.Checked);
    DLIniFile.WriteBool('Options','Core16',Core16RadioButton.Checked);
end;
//-----------------------------------------------------------------------------------------
// Form Create event
//
procedure TForm1.FormCreate(Sender: TObject);
begin
    tCloseButtonPressed := False;
    tCancelButtonPressed := False;
    Global_tExpressionIsSigned := False;
end;
//-----------------------------------------------------------------------------------------
// Form Active event
//
procedure TForm1.FormActivate(Sender: TObject);
begin
    OnActivate := Nil;

    //DeviceGroupBox.Enabled := False;
    //Core14RadioButton.Enabled := False;
    //Core14eRadioButton.Enabled := False;
    //Core16RadioButton.Enabled := False;
    //Core24RadioButton.Enabled := False;
end;
//-----------------------------------------------------------------------------------------
// Form Show event
//
procedure TForm1.FormShow(Sender: TObject);
Var
    CurrentDirectory: String;
begin
    CurrentDirectory := ExtractFileDir(Application.EXEName) + '\';
    If(FileExists(CurrentDirectory + 'Comparison_Gen.ini')) Then
    	Begin
            DLIniFile := TIniFile.Create(CurrentDirectory + 'Comparison_Gen.ini');

            Varin1TypeEditBox.Text := DLIniFile.ReadString('Options','Var1Type','sbyte');
            Varin2TypeEditBox.Text := DLIniFile.ReadString('Options','Var2Type','sbyte');
            ComparisonTypeEditBox.Text := DLIniFile.ReadString('Options','ComparisonType','=');
            BooleanCheckBox.Checked := DLIniFile.ReadBool('Options','Boolean',false);

            Var1StartFromEditBox.Text := DLIniFile.ReadString('Options','Var1Start','-128');
            Var2StartFromEditBox.Text := DLIniFile.ReadString('Options','Var2Start','-128');
            Var1EndAtEditBox.Text := DLIniFile.ReadString('Options','Var1End','127');
            Var2EndAtEditBox.Text := DLIniFile.ReadString('Options','Var2End','127');
            Var1IncrementsEditBox.Text := DLIniFile.ReadString('Options','Var1Inc','1');
            Var2IncrementsEditBox.Text := DLIniFile.ReadString('Options','Var2Inc','1');
            IncrementUp1.Checked := DLIniFile.ReadBool('Options','Var1Up',false);
            IncrementUp2.Checked := DLIniFile.ReadBool('Options','Var2Up',false);
            //
            // Compiler type
            //
            Amicus18RadioButton.Checked := DLIniFile.ReadBool('Options','Amicus18',true);
            ProtonRadioButton.Checked := DLIniFile.ReadBool('Options','Proton',false);
            //
            // Device type
            //
            Core14RadioButton.Checked := DLIniFile.ReadBool('Options','Core14',true);
            Core14eRadioButton.Checked := DLIniFile.ReadBool('Options','Core14e',false);
            Core16RadioButton.Checked := DLIniFile.ReadBool('Options','Core16',false);
        End
    Else
        Begin
            DLIniFile := TIniFile.Create(CurrentDirectory + 'Comparison_Gen.ini');  	// ini file doesn't exist
            DLIniFile.WriteString('Options','Var1Type','sbyte');
            DLIniFile.WriteString('Options','Var2Type','sbyte');
            DLIniFile.WriteString('Options','ComparisonType','=');
            DLIniFile.WriteBool('Options','Boolean',false);

            DLIniFile.WriteString('Options','Var1Start','-128');
            DLIniFile.WriteString('Options','Var2Start','-128');
            DLIniFile.WriteString('Options','Var1End','127');
            DLIniFile.WriteString('Options','Var2End','127');
            DLIniFile.WriteString('Options','Var1Inc','1');
            DLIniFile.WriteString('Options','Var2Inc','1');
            DLIniFile.WriteBool('Options','Var1Up',false);
            DLIniFile.WriteBool('Options','Var2Up',false);
            //
            // Compiler type
            //
            DLIniFile.WriteBool('Options','Amicus18',true);
            DLIniFile.WriteBool('Options','Proton',false);
            //
            // Device type
            //
            DLIniFile.WriteBool('Options','Core14',true);
            DLIniFile.WriteBool('Options','Core14e',false);
            DLIniFile.WriteBool('Options','Core16',false);
        End;
end;
//-----------------------------------------------------------------------------------------
// Form close event
//
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Try
  	DLIniFile.Free;
Except
End;
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.GoButtonClick(Sender: TObject);
var
    VariableValue1: Integer;
    VariableValue2: Integer;
    LoopCount: Integer;
    LoopIncrement: Integer;
    Value1From, Value1To: Integer;
    Value2From, Value2To: Integer;
    Iterations: Integer;
    Var1Increments, Var2Increments: Integer;
    Value1Span, Value2Span: Integer;
begin
    tCloseButtonPressed := False;
    tCancelButtonPressed := False;
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

    ComparisonType := ComparisonTypeEditBox.Text;           // Get the comparison type

    Var1Increments := StrToInt(Var1IncrementsEditBox.Text);
    Var2Increments := StrToInt(Var2IncrementsEditBox.Text);

    Value1From := StrToInt(Var1StartFromEditBox.Text);
    Value1To := StrToInt(Var1EndAtEditBox.Text);

    Value2From := StrToInt(Var2StartFromEditBox.Text);
    Value2To := StrToInt(Var2EndAtEditBox.Text);

    Value1Span := abs(Value1To) + abs(Value1From);               // Find the span of variable 1
    Value2Span := abs(Value2To) + abs(Value2From);               // Find the span of variable 2
    //PrintMessage('Value1Span = ' + IntToStr(Value1Span));
    //PrintMessage('Value2Span = ' + IntToStr(Value2Span));
//
// Get the variable types from examining the edit boxes
//
    GetVariableTypes();
//
// Place the variable declarations
//
    PlaceVariableDeclarations(Global_VariableType1, Global_VariableType2);
//
// comparisons
//
    If(IncrementUp1.Checked = True) Then
        VariableValue1 := Value1From
    Else
        VariableValue1 := Value1To;

    If(IncrementUp2.Checked = True) Then
        VariableValue2 := Value2From
    Else
        VariableValue2 := Value2To;

    LoopCount := 0;
    Memo1.Lines.BeginUpdate();
    Repeat
        //PrintCode(IntToStr(VariableValue1) + ' : ' + IntToStr(VariableValue2));

        If(Global_VariableType1 = cType_Constant) Then
            begin
                Global_VariableName1 := IntToStr(VariableValue1);
            end;
        If(Global_VariableType2 = cType_Constant) Then
            begin
                Global_VariableName2 := IntToStr(VariableValue2);
            end;

        PlaceComparison(VariableValue1, VariableValue2);
        //
        // First variable
        //
        If(IncrementUp1.Checked = True) Then
            begin
                VariableValue1 := VariableValue1 + Var1Increments;
                If(VariableValue1 > Value1To) Then
                    begin
                        VariableValue1 := Value1From;
                    end;
            end
        Else
            begin
                VariableValue1 := VariableValue1 - Var1Increments;
                If(VariableValue1 < Value1From) Then
                    begin
                        VariableValue1 := Value1To;
                    end;
            end;
        //
        // Second variable
        //
        If(IncrementUp2.Checked = True) Then
            begin
                VariableValue2 := VariableValue2 + Var2Increments;
                If(VariableValue2 > Value2To) Then
                    begin
                        VariableValue2 := Value2From;
                    end;
            end
        Else
            begin
                VariableValue2 := VariableValue2 - Var2Increments;
                If(VariableValue2 < Value2From) Then
                    begin
                        VariableValue2 := Value2To;
                    end;
            end;
        LoopCount := LoopCount + 1;

        If(Value1Span > Value2Span) Then
            begin
                Iterations := (Value1To - Value1From) div Var1Increments;
            end
        Else
            begin
                Iterations := (Value2To - Value2From) div Var2Increments;
            end;
        If(tCloseButtonPressed = True) Then Break;
        If(tCancelButtonPressed = True) Then Break;
    Until LoopCount >= Iterations;
    PrintCode('    Stop');

    If((Core14RadioButton.Checked = True) And (LoopCount > 100)) Then
        begin
            Memo1.Clear();
            Memo1.Lines.EndUpdate();
            PrintMessage(IntToStr(LoopCount) + ' Comparisons is too many for a standard 14-bit core device');
        end
    Else
        begin
            Memo1.Lines.EndUpdate();
            If(tCloseButtonPressed = True) Then Exit;
            Memo1.SelectAll();
            Memo1.CopyToClipboard();
            PrintMessage(IntToStr(LoopCount) + ' Comparisons');
            PrintMessage('The test program is now in the clipboard ready to paste into the IDE');
        end;
end;
//-----------------------------------------------------------------------------------------
//
//
procedure TForm1.PlaceComparison(pVariableValue1: Integer; pVariableValue2: Integer);
begin
    If(Global_VariableType1 <> cType_Constant) Then
        begin
            PrintCode('    ' + Global_VariableName1 + ' = ' + IntToStr(pVariableValue1));
        end;
    If(Global_VariableType2 <> cType_Constant) Then
        begin
            PrintCode('    ' + Global_VariableName2 + ' = ' + IntToStr(pVariableValue2));
        end;


    If(BooleanCheckBox.Checked = True) Then
        PrintCode('    If ' + Global_VariableName1 + ' ' + ComparisonType + ' ' + Global_VariableName2 + ' And ' + Global_VariableName1 + ' ' + ComparisonType + ' ' + Global_VariableName2+ ' Then ')
    Else
        PrintCode('    If ' + Global_VariableName1 + ' ' + ComparisonType + ' ' + Global_VariableName2 + ' Then ');
    if(ComparisonType = '<=') Then
        begin
            If(pVariableValue1 <= pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <= ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' > ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <= ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' > ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;
    if(ComparisonType = '<') Then
        begin
            If(pVariableValue1 < pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' < ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' >= ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' < ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' >= ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;
    if(ComparisonType = '>=') Then
        begin
            If(pVariableValue1 >= pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' >= ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' < ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' >= ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' < ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;
    if(ComparisonType = '>') Then
        begin
            If(pVariableValue1 > pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' > ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <= ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' > ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <= ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;
    if(ComparisonType = '=') Then
        begin
            If(pVariableValue1 = pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' = ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <> ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' = ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <> ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;
    if(ComparisonType = '<>') Then
        begin
            If(pVariableValue1 <> pVariableValue2) Then
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <> ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' = ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                end
            Else
                begin
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' <> ' + IntToStr(pVariableValue2) + '" : Gosub _No');
                    PrintCode('    Else');
                    PrintCode('      HRSOut "' + IntToStr(pVariableValue1) + ' = ' + IntToStr(pVariableValue2) + '" : Gosub _Yes');
                end;
        end;

    PrintCode('    Endif');
    PrintCode('''-----------------');
end;
//-----------------------------------------------------------------------------------------
// Get the variable types from what is in the edit boxes
//
procedure TForm1.GetVariableTypes();
Var
    pVariableType1: String;
    pVariableType2: String;
begin
//
// Variable 1
//
    If(Varin1TypeEditBox.Text = 'byte') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType1 := cType_Byte;
            Global_VariableName1 := 'Bytein1';
        end
    Else If(Varin1TypeEditBox.Text = 'word') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType1 := cType_Word;
            Global_VariableName1 := 'Wordin1';
        end
    Else If(Varin1TypeEditBox.Text = 'dword') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType1 := cType_Dword;
            Global_VariableName1 := 'Dwordin1';
        end
    Else If(Varin1TypeEditBox.Text = 'sbyte') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType1 := cType_SByte;
            Global_VariableName1 := 'sBytein1';
        end
    Else If(Varin1TypeEditBox.Text = 'sword') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType1 := cType_SWord;
            Global_VariableName1 := 'sWordin1';
        end
    Else If(Varin1TypeEditBox.Text = 'sdword') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType1 := cType_SDword;
            Global_VariableName1 := 'sDwordin1';
        end
    Else If(Varin1TypeEditBox.Text = 'float') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType1 := cType_Float;
            Global_VariableName1 := 'Floatin1';
        end
    Else If(Varin1TypeEditBox.Text = 'constant') Then
        begin
            Global_VariableType1 := cType_Constant;
        end;
//
// Variable 2
//
    If(Varin2TypeEditBox.Text = 'byte') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType2 := cType_Byte;
            Global_VariableName2 := 'Bytein2';
        end
    Else If(Varin2TypeEditBox.Text = 'word') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType2 := cType_Word;
            Global_VariableName2 := 'Wordin2';
        end
    Else If(Varin2TypeEditBox.Text = 'dword') Then
        begin
            Global_tExpressionIsSigned := False;
            Global_VariableType2 := cType_Dword;
            Global_VariableName2 := 'Dwordin2';
        end
    Else If(Varin2TypeEditBox.Text = 'sbyte') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType2 := cType_SByte;
            Global_VariableName2 := 'sBytein2';
        end
    Else If(Varin2TypeEditBox.Text = 'sword') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType2 := cType_SWord;
            Global_VariableName2 := 'sWordin2';
        end
    Else If(Varin2TypeEditBox.Text = 'sdword') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType2 := cType_SDword;
            Global_VariableName2 := 'sDwordin2';
        end
    Else If(Varin2TypeEditBox.Text = 'float') Then
        begin
            Global_tExpressionIsSigned := True;
            Global_VariableType2 := cType_Float;
            Global_VariableName2 := 'Floatin2';
        end
    Else If(Varin2TypeEditBox.Text = 'constant') Then
        begin
            Global_VariableType2 := cType_Constant;
        end;

    PrintMessage(Varin1TypeEditBox.Text + ' ' + ComparisonType + ' ' + Varin2TypeEditBox.Text);
end;
//-----------------------------------------------------------------------------------------
// Place the Dim statements into the BASIC program
//
procedure TForm1.PlaceVariableDeclarations(pVariableType1: Integer; pVariableType2: Integer);
Var
    VariableString1: String;
    VariableString2: String;
begin
    If(pVariableType1 = cType_Byte) Then
        VariableString1 := 'Byte'
    Else If(pVariableType1 = cType_Word) Then
        VariableString1 := 'Word'
    Else If(pVariableType1 = cType_Dword) Then
        VariableString1 := 'Dword'
    Else If(pVariableType1 = cType_SByte) Then
        VariableString1 := 'SByte'
    Else If(pVariableType1 = cType_SWord) Then
        VariableString1 := 'SWord'
    Else If(pVariableType1 = cType_SDword) Then
        VariableString1 := 'SDword'
    Else If(pVariableType1 = cType_Float) Then
        VariableString1 := 'Float';

    If(pVariableType2 = cType_Byte) Then
        VariableString2 := 'Byte'
    Else If(pVariableType2 = cType_Word) Then
        VariableString2 := 'Word'
    Else If(pVariableType2 = cType_Dword) Then
        VariableString2 := 'Dword'
    Else If(pVariableType2 = cType_SByte) Then
        VariableString2 := 'SByte'
    Else If(pVariableType2 = cType_SWord) Then
        VariableString2 := 'SWord'
    Else If(pVariableType2 = cType_SDword) Then
        VariableString2 := 'SDword'
    Else If(pVariableType2 = cType_Float) Then
        VariableString2 := 'Float';
//
// Create the code at the top of the program for a particular compiler and device
//
    If(Amicus18RadioButton.Checked = True) Then                         // Amicus18?
        begin
            PrintCode(''' Amicus18 Comparison test');
            PrintCode('''');
        end
    Else If(ProtonRadioButton.Checked = True) Then
        begin
            //
            // Choose the device type
            //
            If(Core14RadioButton.Checked = True) Then                   // Standard 14-bit core device?
                begin
                    PrintCode(''' Proton Comparison test for standard 14-bit core devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 16F877');
                    PrintCode('    Declare Xtal = 4');
                    PrintCode('''');
                end
            Else If(Core14eRadioButton.Checked = True) Then             // Enhanced 14-bit core device?
                begin
                    PrintCode(''' Proton Comparison test for enhanced 14-bit core devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 16F1939');
                    PrintCode('    Declare Xtal = 4');
                    PrintCode('''');
                    PrintCode('    Declare Optimiser_Level = 1');
                    PrintCode('    Declare Dead_Code_Remove = On');
                    PrintCode('''');
                end
            Else If(Core16RadioButton.Checked = True) Then              // 18F device?
                begin
                    PrintCode(''' Proton Comparison test for 18F devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 18F452');
                    PrintCode('    Declare Xtal = 4');
                    PrintCode('''');
                    PrintCode('    Declare Optimiser_Level = 1');
                    PrintCode('    Declare Dead_Code_Remove = On');
                    PrintCode('''');
                end;
            PrintCode('    Declare Hserial_Baud = 9600');
            PrintCode('    Declare Hserial_RCSTA = %10010000');
            PrintCode('    Declare Hserial_TXSTA = %00100100');
            PrintCode('    Declare Hserial_Clear = On');
            PrintCode('''');
        end;

    If(pVariableType1 <> cType_Constant) Then                                       // Is the left hand variable actually a constant value?
        begin                                                                       // No. So...
            PrintCode('    Dim ' + Global_VariableName1 + ' As ' + VariableString1);  // Add the declaration for the variable type
        end;
    If(pVariableType2 <> cType_Constant) Then                                       // Is the right hand variable actually a constant value?
        begin
            PrintCode('    Dim ' + Global_VariableName2 + ' As ' + VariableString2);  // Add the declaration for the variable type
        end;
    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('    Goto Main');
    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('_Yes:');
    PrintCode('    HRSOut " Yes\r"');
    PrintCode('    Return');
    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('_No:');
    PrintCode('    HRSOut " No ********\r"');
    PrintCode('    Return');
    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('Main:');
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.PrintCode(pText: String);
begin
    Memo1.Lines.Add(pText);
    Application.ProcessMessages();
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.PrintMessage(pText: String);
begin
    Memo2.Lines.Add(pText);
    Application.ProcessMessages();
end;

//-----------------------------------------------------------------------------------------
// Compiler Group Box - Amicus18 chosen event
//
procedure TForm1.Amicus18RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

    DeviceGroupBox.Enabled := False;
    Core14RadioButton.Enabled := False;
    Core14eRadioButton.Enabled := False;
    Core16RadioButton.Enabled := False;
end;
//-----------------------------------------------------------------------------------------
// Compiler Group Box - Proton chosen event
//
procedure TForm1.ProtonRadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

    DeviceGroupBox.Enabled := True;
    Core14RadioButton.Enabled := True;
    Core14eRadioButton.Enabled := True;
    Core16RadioButton.Enabled := True;
//
// Disable unsupported devices and activate supported devices within the Device Group box
//
    Core14RadioButton.Enabled := True;
    Core14eRadioButton.Enabled := True;
    Core16RadioButton.Enabled := True;
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core14RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core14eRadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core16RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;

end.
